// PIanarView.cpp : implementation of the CPIanarView class
//

#include "stdafx.h"
#include "PIanar.h"

#include "PIanarDoc.h"
#include "PIanarView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define r 10
CList List;

/////////////////////////////////////////////////////////////////////////////
// CPIanarView

IMPLEMENT_DYNCREATE(CPIanarView, CView)

BEGIN_MESSAGE_MAP(CPIanarView, CView)
	//{{AFX_MSG_MAP(CPIanarView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPIanarView construction/destruction

CPIanarView::CPIanarView()
{
	// TODO: add construction code here

}

CPIanarView::~CPIanarView()
{
}

BOOL CPIanarView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPIanarView drawing

void CPIanarView::OnDraw(CDC* pDC)
{
	CPIanarDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	Rib *RElnt = List.RHead;
	while (RElnt != NULL)
	{
		pDC->MoveTo (List[RElnt->a]->x, List[RElnt->a]->y);
		pDC->LineTo (List[RElnt->b]->x, List[RElnt->b]->y);
		RElnt = RElnt->Next;
	}
	
	Dot *DElnt = List.DHead; 
	while (DElnt != NULL)
	{
		pDC->Ellipse (DElnt->x - r, DElnt->y - r, DElnt->x + r, DElnt->y + r);
		DElnt = DElnt->Next;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPIanarView printing

BOOL CPIanarView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPIanarView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPIanarView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CPIanarView diagnostics

#ifdef _DEBUG
void CPIanarView::AssertValid() const
{
	CView::AssertValid();
}

void CPIanarView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPIanarDoc* CPIanarView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPIanarDoc)));
	return (CPIanarDoc*)m_pDocument;
}
#endif //_DEBUG

bool CPIanarView::CheckPlanar()
{
	//first step: the primitivest cases
	if(List.DN < 5 || List.RN < 9 || (List.DN == 5 && List.RN == 9)) return true;
	
	int i1, i2, i3, i4, i5;

	//next step:  k5
	for(i1 = 0; i1 < List.DN; i1 ++)     
	for(i2 = i1; i2 < List.DN; i2 ++) 
	for(i3 = i2; i3 < List.DN; i3 ++)  
	for(i4 = i3; i4 < List.DN; i4 ++)  
	for(i5 = i4; i5 < List.DN; i5 ++) 
	if(List.RE(i1, i2)&&List.RE(i1, i3)&&List.RE(i1, i4)&&List.RE(i1, i5)&&List.RE(i2, i3)&&List.RE(i2, i4)
			&&List.RE(i2, i5)&&List.RE(i3, i4)&&List.RE(i3, i5)&&List.RE(i4, i5)) return false;

	int i6;
	
	//next step: k3,3
	for(i1 = 0; i1 < List.DN; i1 ++) 
	for(i2 = 0; i2 < List.DN; i2 ++) 
		if(i1 == i2) continue; else
	for(i3 = 0; i3 < List.DN; i3 ++) 
		if(i1 == i3 || i2 == i3) continue; else
	for(i4 = 0; i4 < List.DN; i4 ++) 
		if(i1 == i4 || i2 == i4 || i3 == i4) continue; else
	for(i5 = 0; i5 < List.DN; i5 ++) 
		if(i1 == i5 || i2 == i5 || i3 == i5 || i4 == i5) continue; else
	for(i6 = 0; i6 < List.DN; i6 ++)
		if(i1 == i6 || i2 == i6 || i3 == i6 || i4 == i6 || i5 == i6) continue; else
		if(List.RE(i1, i4)&&List.RE(i1, i5)&&List.RE(i1, i6)&&List.RE(i2, i4)&&
	List.RE(i2, i5)&&List.RE(i2, i6)&&List.RE(i3, i4)&&List.RE(i3, i5)&&List.RE(i3, i6)) return false;
	return true;
}



/////////////////////////////////////////////////////////////////////////////
// CPIanarView message handlers
int DotChecked =-1;
void CPIanarView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CView::OnLButtonDown(nFlags, point);

	Dot *DElnt = List.DHead;
	for(int i = 0; DElnt != NULL; i++, DElnt = DElnt->Next)
		if((DElnt->x - point.x)*(DElnt->x - point.x) + (DElnt->y - point.y)*(DElnt->y - point.y) <= r*r)
		{
			if(DotChecked != -1 && DotChecked != i) 
			{
				Rib *temp = new Rib;
				temp->a = DotChecked;
				temp->b = i;
				temp->Next = NULL;
				List.Append(temp);
				DotChecked = -1;
			}
			else
				DotChecked = i;

			Invalidate();
			return;
		}
	
	Dot *temp = new Dot;
	temp->x = point.x;
	temp->y = point.y;
	temp->Next = NULL;
	List.Append(temp);

	Invalidate();
}


void CPIanarView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CView::OnRButtonDown(nFlags, point);

	char *text = new char[17];
	if(CheckPlanar())
		text = " ";
	else text = "  ";
	MessageBox(text, NULL, MB_OK);
}